package local.ua;

public class SoundRecorder 
{
	private SoundFileWriterInterface curWriter=null;
	private String baseFilename=null;
	private String curCodec=null;
	private int curPiece=100;
	
	public SoundRecorder(String argBaseFilename)
	{
		baseFilename=argBaseFilename;
	}
	
	public void write(String codecName,byte[] data,int offset,int len)
	{
		if (curWriter==null || !codecName.equals(curCodec))
		{	
			close();

			curPiece++;
			curCodec=codecName;
			
			if (codecName.equals("PCM"))
				curWriter=new WavWriter(baseFilename+"_"+Integer.toString(curPiece).substring(1)+".wav",WavWriter.SubFormat.PCM);
			else if (codecName.equals("PCMU"))	
			    curWriter=new AUWriter(baseFilename+"_"+Integer.toString(curPiece).substring(1)+".au",AUWriter.LawFormat.ULAW);
			else if (codecName.equals("PCMA"))	
			    curWriter=new AUWriter(baseFilename+"_"+Integer.toString(curPiece).substring(1)+".au",AUWriter.LawFormat.ALAW);
			//else if (codecName.equals("GSM"))	
			//	   curWriter=new WavWriter(baseFilename+"_"+Integer.toString(curPiece).substring(1)+".wav",WavWriter.SubFormat.GSM);
			else
			{
				curWriter=null;
				return;
			}
			//else if (codecName.equals("iLBC"))	
			 //   curWriter=new ILBCWriter(baseFilename+"_"+Integer.toString(curPiece).substring(1)+".au");
			//else if (codecName.equals("speex"))	
			 //   curWriter=new SPEEXWriter(baseFilename+"_"+Integer.toString(curPiece).substring(1)+".au");

		}
		
		curWriter.write(data,offset,len);
	}
	
	public void close()
	{
		if (curWriter!=null)
			curWriter.close();
	}
	
}
